
void OnRecvOpen (SIMCONNECT_RECV_OPEN *pOpen, DWORD cbData)
{
	hr = SimConnect_SubscribeToSystemEvent( hSimConnect, CLIENT_EVENT_6HZ, "6Hz" );

	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK RIGHT MAIN CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK LEFT MAIN CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK RIGHT AUX CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK LEFT AUX CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK RIGHT TIP CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK LEFT TIP CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK CENTER CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK CENTER2 CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK CENTER3 CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK EXTERNAL1 CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_CAPACITY, "FUEL TANK EXTERNAL2 CAPACITY", "Gallons",SIMCONNECT_DATATYPE_FLOAT64,0);

	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 0, "FUEL TANK RIGHT MAIN QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 1, "FUEL TANK LEFT MAIN QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 2, "FUEL TANK RIGHT AUX QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 3, "FUEL TANK LEFT AUX QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 4, "FUEL TANK RIGHT TIP QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 5, "FUEL TANK LEFT TIP QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 6, "FUEL TANK CENTER QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 7, "FUEL TANK CENTER2 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 8, "FUEL TANK CENTER3 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 9, "FUEL TANK EXTERNAL1 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, 10, "FUEL TANK EXTERNAL2 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);

	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK RIGHT MAIN QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK LEFT MAIN QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK RIGHT AUX QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK LEFT AUX QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK RIGHT TIP QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK LEFT TIP QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK CENTER QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK CENTER2 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK CENTER3 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK EXTERNAL1 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_FUEL_LEVELS, "FUEL TANK EXTERNAL2 QUANTITY", "Gallons", SIMCONNECT_DATATYPE_FLOAT64, 0);

	if ( SUCCEEDED(hr) ) hr = SimConnect_RequestDataOnSimObject( hSimConnect, DATA_REQUEST_FUEL_CAPACITY, DATA_DEFINITION_FUEL_CAPACITY,SIMCONNECT_OBJECT_ID_USER, SIMCONNECT_PERIOD_ONCE, NULL, NULL, NULL, NULL );
	if ( SUCCEEDED(hr) ) hr = SimConnect_RequestDataOnSimObject( hSimConnect, DATA_REQUEST_FUEL_LEVELS, DATA_DEFINITION_FUEL_LEVELS,SIMCONNECT_OBJECT_ID_USER, SIMCONNECT_PERIOD_SIM_FRAME, NULL, NULL, NULL, NULL );
}

void OnRecvEvent (SIMCONNECT_RECV_EVENT *pEvent, DWORD cbData)
{
	switch (pEvent->uEventID)
		{
		case CLIENT_EVENT_6HZ:
			{
			lookup_var( &mvSeconds );
			int i = 0;
			while ( i < 11 )
				{
				fActiveTank = Tank[i].lv.GetLVar();
				if ( fActiveTank != 0. && Tank[i].active == 0 && Tank[i].capacity > 0. ) 
					{
					Tank[i].active = 1;
					Tank[i].now = mvSeconds.var_value.n;
					}
				else if ( fActiveTank == 0. && Tank[i].active == 1 )
					{
					Tank[i].active = 0;
					}
				i++;
				}
			}
		break;
		}
}
void FSAPI TankRoutine(int t)
{
	Tank[t].level = fLevel[t];
		// Update the dump rate.
	Tank[t].rate = Tank[t].lv.GetLVar();
		//Time that has elapsed since we were last here.
	Tank[t].then = Tank[t].now;
	Tank[t].now = mvSeconds.var_value.n;
	TimeSlice = Tank[t].now - Tank[t].then;  
	if ( TimeSlice < 0. ) TimeSlice = 0.;
	if ( TimeSlice > 2. ) TimeSlice = 0.;
		// The amount of fuel we are going to drop.
	RateGPS = (Tank[t].rate / 3.600) / mvWeight.var_value.n;
	FuelChange = (TimeSlice * RateGPS) / 1000.;
		//  We can't drop more than we have, and we can't add more than the available capacity.
	if ( FuelChange > Tank[t].level ) FuelChange = Tank[t].level;
	if ( FuelChange < Tank[t].level - Tank[t].capacity ) FuelChange = Tank[t].level - Tank[t].capacity;
		// Making FuelChange equal to the new value we are going to write
	FuelChange = Tank[t].level - FuelChange;
		// Write the new fuel level.
	if ( FuelChange != Tank[t].level )
		SimConnect_SetDataOnSimObject(hSimConnect, t, SIMCONNECT_SIMOBJECT_TYPE_USER, NULL, NULL, sizeof(double), &FuelChange );
#ifdef _DEBUG
		dwCount++;
		fprintf_s( fLog,"\nCount=%d Tank=%d Old=%6.8f Rate=%5.2f Change=%3.8f New=%6.8f Time=%1.8f PPH=%f GPS=%f", dwCount,t,Tank[t].level, Tank[t].rate,Tank[t].level-FuelChange,FuelChange,TimeSlice, Tank[t].rate, RateGPS);
#endif
}

void OnRecvSimobjectData(SIMCONNECT_RECV_SIMOBJECT_DATA *pData, DWORD cbData)
{
	iFlip++;
	if( iFlip > 2 ) iFlip = 0;
	if( pData->dwDefineID == DATA_DEFINITION_FUEL_CAPACITY )
		{
		lookup_var( &mvWeight );
		pFuel = (_FuelInfo*)&pData->dwData;
		Tank[TANK_MAIN_RIGHT].capacity = pFuel->RightMain;
		Tank[TANK_MAIN_LEFT].capacity = pFuel->LeftMain;
		Tank[TANK_AUX_RIGHT].capacity = pFuel->RightAux;
		Tank[TANK_AUX_LEFT].capacity = pFuel->LeftAux;
		Tank[TANK_TIP_RIGHT].capacity = pFuel->RightTip;
		Tank[TANK_TIP_LEFT].capacity = pFuel->LeftTip;
		Tank[TANK_CENTER].capacity = pFuel->Center;
		Tank[TANK_CENTER2].capacity = pFuel->Center2;
		Tank[TANK_CENTER3].capacity = pFuel->Center3;
		Tank[TANK_EXTERNAL1].capacity = pFuel->External1;
		Tank[TANK_EXTERNAL2].capacity = pFuel->External2;
		}
	if( pData->dwDefineID == DATA_DEFINITION_FUEL_LEVELS )
		{
		pFuel = (_FuelInfo*)&pData->dwData;
		fLevel[TANK_MAIN_RIGHT] = pFuel->RightMain;
		fLevel[TANK_MAIN_LEFT] = pFuel->LeftMain;
		fLevel[TANK_AUX_RIGHT] = pFuel->RightAux;
		fLevel[TANK_AUX_LEFT] = pFuel->LeftAux;
		fLevel[TANK_TIP_RIGHT] = pFuel->RightTip;
		fLevel[TANK_TIP_LEFT] = pFuel->LeftTip;
		fLevel[TANK_CENTER] = pFuel->Center;
		fLevel[TANK_CENTER2] = pFuel->Center2;
		fLevel[TANK_CENTER3] = pFuel->Center3;
		fLevel[TANK_EXTERNAL1] = pFuel->External1;
		fLevel[TANK_EXTERNAL2] = pFuel->External2;
		j = 0;
		lookup_var( &mvSeconds );
		while ( iFlip == 0 && j <= TANK_EXTERNAL2 )
			{
			if ( Tank[j].active == 1 ) TankRoutine(j);
			j++;
			}
		}
}
/*
void OnRecvSimobjectDataByType(SIMCONNECT_RECV_SIMOBJECT_DATA_BYTYPE *pObjData, DWORD cbData)
{
}
void OnRecvSimObjectFrame( SIMCONNECT_RECV_EVENT_FRAME *pFrame, DWORD cbData )
{
}
void OnRecvWeatherObservation(SIMCONNECT_RECV_WEATHER_OBSERVATION *pWeather)
{
}
void OnRecvException(SIMCONNECT_RECV_EXCEPTION *px, DWORD cbData)
{
}
*/