char display_gauge_name[]  = GAUGE_NAME;
extern PELEMENT_HEADER   display_list;
extern MOUSERECT     display_mouse_rect[];

#define GAUGE_CHARSET2           DEFAULT_CHARSET
#define GAUGE_FONT_DEFAULT2          "Arial"
#define GAUGE_WEIGHT_DEFAULT2     FW_MEDIUM

int jj=0;
// Mouse functions to scroll through the list of tanks.
BOOL FSAPI mouse_cb2( PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	jj--;
	if ( jj < 0 ) jj = 10;
    return FALSE;
}
BOOL FSAPI mouse_cb3( PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	jj++;
	if ( jj > 10 ) jj = 0;
	return FALSE;
}

MOUSE_BEGIN(display_mouse_rect,0,0,0)

MOUSE_PARENT_BEGIN(1,1,149,48,HELP_NONE)
	MOUSE_TOOLTIP_STANDARD_STRING("Previous")
MOUSE_PARENT_END
MOUSE_PARENT_BEGIN(150,1,149,48,HELP_NONE)
	MOUSE_TOOLTIP_STANDARD_STRING("Next")
MOUSE_PARENT_END

MOUSE_CHILD_FUNCT(1,1,149,48,CURSOR_DOWNARROW,MOUSE_LEFTSINGLE|MOUSE_DOWN_REPEAT,mouse_cb2)
MOUSE_CHILD_FUNCT(150,1,149,48,CURSOR_UPARROW,MOUSE_LEFTSINGLE|MOUSE_DOWN_REPEAT,mouse_cb3)
MOUSE_END


FLOAT64 FSAPI callback2( PELEMENT_STRING pelement) // Top
{
	sprintf(pelement->string,"ID: %d; LVAR: %s", jj, Tank[jj].lv.GetNameA() );
	return 0;
}

FLOAT64 FSAPI callback4( PELEMENT_STRING pelement)  // Bottom
{
	sprintf(pelement->string,"Cap: %6.1f; Level: %6.1f; Rate: %4.1f", Tank[jj].capacity, fLevel[jj], Tank[jj].rate );
	return 0;
}

GAUGE_HEADER_FS800(GAUGEHDR_VAR_NAME, GAUGE_W, display_gauge_name, &display_list, display_mouse_rect, NULL, 0, 0);

MAKE_STRING(String4,NULL,NULL,IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | BIT7,0,
			5,32,280,18,130,MODULE_VAR_NONE,MODULE_VAR_NONE,MODULE_VAR_NONE,RGB(255,255,255),RGB(0,0,0),RGB(0,0,0),
			GAUGE_FONT_DEFAULT2,GAUGE_WEIGHT_DEFAULT2,GAUGE_CHARSET2,0,0,NULL,callback4)
PELEMENT_HEADER ElementList2[] = {&String4.header,NULL};

MAKE_STRING(String2,&ElementList2,NULL,IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | BIT7,0,
			5,5,280,18,130,MODULE_VAR_NONE,MODULE_VAR_NONE,MODULE_VAR_NONE,RGB(255,255,255),RGB(0,0,0),RGB(0,0,0),
			GAUGE_FONT_DEFAULT2,GAUGE_WEIGHT_DEFAULT2,GAUGE_CHARSET2,0,0,NULL,callback2)
PELEMENT_HEADER ElementList4[] = {&String2.header,NULL};

MAKE_STATIC(DisplayStatic,DisplayBitmap,&ElementList4,NULL,IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | BIT7,0,0,0)
PELEMENT_HEADER display_list = &DisplayStatic.header;

